## PyFunge version 0.2 -- http://pyfunge.kldp.net/
## Copyright (c) 2004, Kang Seonghoon (Tokigun).
##
## Permission is hereby granted, free of charge, to any person obtaining a copy
## of this software and associated documentation files (the "Software"), to deal
## in the Software without restriction, including without limitation the rights
## to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
## copies of the Software, and to permit persons to whom the Software is
## furnished to do so, subject to the following conditions:
## 
## The above copyright notice and this permission notice shall be included in all
## copies or substantial portions of the Software.
## 
## THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
## IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
## FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
## AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
## LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
## OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
## SOFTWARE.
##
## $Id: __init__.py,v 1.5 2004/12/12 06:34:40 tokigun Exp $

def __get_date():
    return ' '.join('$Date: 2004/12/12 06:34:40 $'.split()[1:3])

def __get_version():
    import os.path
    filename = os.path.join(os.path.dirname(__file__), 'VERSION')
    return open(filename).read().strip().split()[1]

# docstring
__doc__ = """\
This is PyFunge core package(pyfunge-core), version 0.2.

For more information, see:
    http://pyfunge.kldp.net/
"""

# author
__author__ = """\
PyFunge team:
    Kang Seonghoon <tokigun@gmail.com>
    Kyung-hoon Puzzlet Chung <puzzlet@gmail.com>
"""

# all modules
__all__ = ['exception', 'execute', 'fingerprint', 'ip', 'platform', 'space', 'stack']

# date
__date__ = __get_date()

# version info
__version__ = __get_version()

