## PyFunge version 0.2 -- http://pyfunge.kldp.net/
## Copyright (c) 2004, Kang Seonghoon (Tokigun).
## This program is distributable under the MIT license.
##
## $Id: pyfunge.py,v 1.1 2004/12/12 06:38:48 tokigun Exp $

"""PyFunge 0.2 frontend: main module -- http://pyfunge.kldp.net/
This program is distributable under the MIT license.
$Id: pyfunge.py,v 1.1 2004/12/12 06:38:48 tokigun Exp $
"""

import os, sys, time
try: import psyco; psyco.full()
except: pass

# PyFunge internal module
from core.exception import *
import core.execute, core.platform

def main(argv):
    if len(argv) != 2:
        print "PyFunge 0.2 Frontend (Text)"
        print "Copyright (c) 2004, PyFunge devel team."
        print
        print "Usage: python %s hello.bf" % argv[0]
        return 0
    
    try:
        str = file(argv[1], 'rb').read()
    except:
        print "Error: Cannot read source file -- \"%s\"" % argv[1]
        return 1
    
    try:
        plat = getattr(core.platform, 'FungePlatform_' + os.name)()
    except:
        print "Error: This platform is not supported currently."
        return 1
    
    # for debugging
    def excinfo(exc):
        try:
            print chr(exc.space.get(exc.iplist[1].position)),
        except:
            print ' ',
        print exc.iplist[1].position, exc.iplist[1].delta,
        print len(exc.iplist[1].stack.stack[0].stack),
        print exc.iplist[1].stack.stack[0].stack[-20:],
        raw_input()
    
    exc = core.execute.FungeExec_Befunge98(plat, argv=argv)
    exc.space.putspace((0, 0), str)
    while len(exc.iplist):
        #excinfo(exc)
        exc.executeall()
    
    return 0

if __name__ == '__main__':
    sys.exit(main(sys.argv))

